#include <cstdlib>
#include <iostream>
#include <memory>
#include <vector>

#include "constexp.h"
#include "ifswitch.h"
#include "initlist.h"
#include "null.h"
#include "structured_binding.h"
#include "type_inference.h"
#include "version.h"

int main(int argc, char **argv) {

  std::cout << "Running " << PROJECT_NAME << ", version " << VERSION
            << std::endl;

  std::vector<std::unique_ptr<ChapterTest>> chapter_2_tests;

  chapter_2_tests.emplace_back(std::make_unique<NullTest>());
  chapter_2_tests.emplace_back(std::make_unique<IfswitchTest>());
  chapter_2_tests.emplace_back(std::make_unique<ConstExpTest>());
  chapter_2_tests.emplace_back(std::make_unique<InitListTest>());
  chapter_2_tests.emplace_back(std::make_unique<StructuredBindingTest>());
  chapter_2_tests.emplace_back(std::make_unique<TypeInferenceTest>());

  for (auto &test : chapter_2_tests) {
    std::cout << "\n" << test->name() << ":" << std::endl;
    test->run();
  }

  std::cout << "\nExiting" << std::endl;

  return EXIT_SUCCESS;
}
